/***************************************************************************
 *   Copyright (C) 2006 by M.Fedotov   *
 *   anyremote@mail.ru   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

#include "kanyremote.h"
#include "ar_dcop.h"
#include "ar_client.h"
#include "ar_parser.h"
#include "ar_cmds.h"

extern KAnyRemote*	mainWin;
extern AR_Client*	theClient;
extern AR_Parser*	conf;
extern AR_Cmds*		commander;

AR_dcop::AR_dcop() : DCOPObject("serviceInterface")
{
}


AR_dcop::~AR_dcop()
{
}

bool AR_dcop::isConnected()
{
    return theClient->isConnected();
}

void AR_dcop::Connect()
{
    if(!theClient->isConnected()) {
    	mainWin->Connect();
    }
}

void AR_dcop::Disconnect()
{
    if(theClient->isConnected()) {
    	mainWin->Connect();
    }
}

void AR_dcop::remoteOn(bool set)
{
    commander->setRemoteOn(set);
}

QString AR_dcop::getCfgFile()
{
    return mainWin->cfgFileName;
}

void AR_dcop::setCfgFile(QString file) 
{
    mainWin->SetCfgFile(file);
}

void AR_dcop::setMode(QString mode)
{
    commander->setMode(mode);
}


QString AR_dcop::getMode()
{
    return conf->getMode();
}

void AR_dcop::sendCommand(QString command)
{
        cmdItem* cmd = NULL;
        conf->storeCmds(&cmd, (char*) command.ascii());
        commander->processCommands(cmd, NULL);
        
        cmdItem* mi;
        while (cmd) {
            mi = cmd->next;
            delete cmd;
            cmd = mi;
        }      
}
